# Interface SamReader.PrimitiveSamReader

All Known Implementing Classes:
  `BAMFileReader, CRAMFileReader, HtsgetBAMFileReader, SamReader.ReaderImplementation`

Enclosing interface:
  `SamReader`

public static interface SamReader.PrimitiveSamReader
The minimal subset of functionality needed for a `SAMRecord` data source. `SamReader` itself is somewhat large and bulky, but the core functionality can be captured in relatively few methods, which are included here. For documentation, see the corresponding methods in `SamReader`. See also: `SamReader.PrimitiveSamReaderToSamReaderAdapter`, `SamReader.ReaderImplementation`

## Method Summary

Modifier and Type
Method
Description
`void`
`close()`
`SAMFileHeader`
`getFileHeader()`
`SAMFileSpan`
`getFilePointerSpanningReads()`
`BAMIndex`
`getIndex()`
`CloseableIterator<SAMRecord>`
`getIterator()`
`CloseableIterator<SAMRecord>`
`getIterator(SAMFileSpan fileSpan)`
`ValidationStringency`
`getValidationStringency()`
`boolean`
`hasIndex()`
`default boolean`
`isQueryable()`
`CloseableIterator<SAMRecord>`
`query(QueryInterval[] intervals, boolean contained)`
`CloseableIterator<SAMRecord>`
`queryAlignmentStart(String sequence, int start)`
`CloseableIterator<SAMRecord>`
`queryUnmapped()`
`SamReader.Type`
`type()`

## Method Details

### type

SamReader.Type type()

### isQueryable

default boolean isQueryable()

### hasIndex

boolean hasIndex()

### getIndex

BAMIndex getIndex()

### getFileHeader

SAMFileHeader getFileHeader()

### getIterator

CloseableIterator<SAMRecord> getIterator()

### getIterator

CloseableIterator<SAMRecord> getIterator(SAMFileSpan fileSpan)

### getFilePointerSpanningReads

SAMFileSpan getFilePointerSpanningReads()

### query

CloseableIterator<SAMRecord> query(QueryInterval[] intervals, boolean contained)

### queryAlignmentStart

CloseableIterator<SAMRecord> queryAlignmentStart(String sequence, int start)

### queryUnmapped

CloseableIterator<SAMRecord> queryUnmapped()

### close

void close()

### getValidationStringency

ValidationStringency getValidationStringency()